- Home
- Download

- GitHub

- News
- Documentation

- FAQ
- Tutorial
- API reference
- Examples

- XML Digital Signature
- XML Encryption
- XML Canonicalization
- Reporting Bugs
- Mailing list
- Related
- Authors

## crypto

crypto

## Stability Level

Stable, unless otherwise indicated

## Functions

xmlSecCryptoDLFunctionsPtr | xmlSecCryptoGetFunctions_gnutls ()
int | xmlSecGnuTLSInit ()
int | xmlSecGnuTLSShutdown ()
int | xmlSecGnuTLSKeysMngrInit ()
int | xmlSecGnuTLSGenerateRandom ()
xmlSecKeyPtr | xmlSecGnuTLSAsymmetricKeyCreatePub ()
xmlSecKeyPtr | xmlSecGnuTLSAsymmetricKeyCreatePriv ()
gnutls_pubkey_t | xmlSecGnuTLSAsymmetricKeyGetPub ()
gnutls_privkey_t | xmlSecGnuTLSAsymmetricKeyGetPriv ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataAesGetKlass ()
int | xmlSecGnuTLSKeyDataAesSet ()
xmlSecTransformId | xmlSecGnuTLSTransformAes128CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformAes192CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformAes256CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformAes128GcmGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformAes192GcmGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformAes256GcmGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWAes128GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWAes192GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWAes256GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataChaCha20GetKlass ()
int | xmlSecGnuTLSKeyDataChaCha20Set ()
xmlSecTransformId | xmlSecGnuTLSTransformChaCha20GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformChaCha20Poly1305GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataDesGetKlass ()
int | xmlSecGnuTLSKeyDataDesSet ()
xmlSecTransformId | xmlSecGnuTLSTransformDes3CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWDes3GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataCamelliaGetKlass ()
int | xmlSecGnuTLSKeyDataCamelliaSet ()
xmlSecTransformId | xmlSecGnuTLSTransformCamellia128CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformCamellia192CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformCamellia256CbcGetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWCamellia128GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWCamellia192GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformKWCamellia256GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataDsaGetKlass ()
int | xmlSecGnuTLSKeyDataDsaAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataDsaGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataDsaGetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformDsaSha1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformDsaSha256GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataEcGetKlass ()
int | xmlSecGnuTLSKeyDataEcAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataEcGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataEcGetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha512GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha3_224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha3_256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha3_384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdsaSha3_512GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataGost2001GetKlass ()
int | xmlSecGnuTLSKeyDataGost2001AdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataGost2001GetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataGost2001GetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformGostR3411_94GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformGost2001GostR3411_94GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataGost2012_256GetKlass ()
int | xmlSecGnuTLSKeyDataGost2012_256AdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataGost2012_256GetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataGost2012_256GetPrivateKey ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataGost2012_512GetKlass ()
int | xmlSecGnuTLSKeyDataGost2012_512AdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataGost2012_512GetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataGost2012_512GetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformGostR3411_2012_256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformGostR3411_2012_512GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataMLDSAGetKlass ()
int | xmlSecGnuTLSKeyDataMLDSAAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataMLDSAGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataMLDSAGetPrivateKey ()
int | xmlSecGnuTLSKeyDataMLDSAGetKL ()
xmlSecTransformId | xmlSecGnuTLSTransformMLDSA44GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformMLDSA65GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformMLDSA87GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataEdDSAGetKlass ()
int | xmlSecGnuTLSKeyDataEdDSAAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataEdDSAGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataEdDSAGetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformEdDSAEd25519GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEdDSAEd448GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataXdhGetKlass ()
int | xmlSecGnuTLSKeyDataXdhAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataXdhGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataXdhGetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformX25519GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformX448GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformEcdhGetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataConcatKdfGetKlass ()
int | xmlSecGnuTLSKeyDataConcatKdfSet ()
xmlSecTransformId | xmlSecGnuTLSTransformConcatKdfGetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataHmacGetKlass ()
int | xmlSecGnuTLSKeyDataHmacSet ()
xmlSecTransformId | xmlSecGnuTLSTransformHmacSha1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformHmacSha224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformHmacSha256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformHmacSha384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformHmacSha512GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataPbkdf2GetKlass ()
int | xmlSecGnuTLSKeyDataPbkdf2Set ()
xmlSecTransformId | xmlSecGnuTLSTransformPbkdf2GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataHkdfGetKlass ()
int | xmlSecGnuTLSKeyDataHkdfSet ()
xmlSecTransformId | xmlSecGnuTLSTransformHkdfGetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataRsaGetKlass ()
int | xmlSecGnuTLSKeyDataRsaAdoptKey ()
gnutls_pubkey_t | xmlSecGnuTLSKeyDataRsaGetPublicKey ()
gnutls_privkey_t | xmlSecGnuTLSKeyDataRsaGetPrivateKey ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaSha1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaSha224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaSha256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaSha384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaSha512GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaPssSha256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaPssSha384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaPssSha512GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformRsaPkcs1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha1GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha512GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha3_224GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha3_256GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha3_384GetKlass ()
xmlSecTransformId | xmlSecGnuTLSTransformSha3_512GetKlass ()
xmlSecKeyDataId | xmlSecGnuTLSKeyDataDEREncodedKeyValueGetKlass ()

## Types and Values

#define | xmlSecGnuTLSKeyDataAesId
#define | xmlSecGnuTLSTransformAes128CbcId
#define | xmlSecGnuTLSTransformAes192CbcId
#define | xmlSecGnuTLSTransformAes256CbcId
#define | xmlSecGnuTLSTransformAes128GcmId
#define | xmlSecGnuTLSTransformAes192GcmId
#define | xmlSecGnuTLSTransformAes256GcmId
#define | xmlSecGnuTLSTransformKWAes128Id
#define | xmlSecGnuTLSTransformKWAes192Id
#define | xmlSecGnuTLSTransformKWAes256Id
#define | xmlSecGnuTLSKeyDataChaCha20Id
#define | xmlSecGnuTLSTransformChaCha20Id
#define | xmlSecGnuTLSTransformChaCha20Poly1305Id
#define | xmlSecGnuTLSKeyDataDesId
#define | xmlSecGnuTLSTransformDes3CbcId
#define | xmlSecGnuTLSTransformKWDes3Id
#define | xmlSecGnuTLSKeyDataCamelliaId
#define | xmlSecGnuTLSTransformCamellia128CbcId
#define | xmlSecGnuTLSTransformCamellia192CbcId
#define | xmlSecGnuTLSTransformCamellia256CbcId
#define | xmlSecGnuTLSTransformKWCamellia128Id
#define | xmlSecGnuTLSTransformKWCamellia192Id
#define | xmlSecGnuTLSTransformKWCamellia256Id
#define | xmlSecGnuTLSKeyDataDsaId
#define | xmlSecGnuTLSTransformDsaSha1Id
#define | xmlSecGnuTLSTransformDsaSha256Id
#define | xmlSecGnuTLSKeyDataEcId
#define | xmlSecGnuTLSTransformEcdsaSha1Id
#define | xmlSecGnuTLSTransformEcdsaSha224Id
#define | xmlSecGnuTLSTransformEcdsaSha256Id
#define | xmlSecGnuTLSTransformEcdsaSha384Id
#define | xmlSecGnuTLSTransformEcdsaSha512Id
#define | xmlSecGnuTLSTransformEcdsaSha3_224Id
#define | xmlSecGnuTLSTransformEcdsaSha3_256Id
#define | xmlSecGnuTLSTransformEcdsaSha3_384Id
#define | xmlSecGnuTLSTransformEcdsaSha3_512Id
#define | xmlSecGnuTLSKeyDataGost2001Id
#define | xmlSecGnuTLSTransformGostR3411_94Id
#define | xmlSecGnuTLSTransformGost2001GostR3411_94Id
#define | xmlSecGnuTLSKeyDataGost2012_256Id
#define | xmlSecGnuTLSKeyDataGost2012_512Id
#define | xmlSecGnuTLSTransformGostR3411_2012_256Id
#define | xmlSecGnuTLSTransformGostR3411_2012_512Id
#define | xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256Id
#define | xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512Id
#define | xmlSecGnuTLSKeyDataMLDSAId
#define | xmlSecGnuTLSTransformMLDSA44Id
#define | xmlSecGnuTLSTransformMLDSA65Id
#define | xmlSecGnuTLSTransformMLDSA87Id
#define | xmlSecGnuTLSKeyDataEdDSAId
#define | xmlSecGnuTLSTransformEdDSAEd25519Id
#define | xmlSecGnuTLSTransformEdDSAEd448Id
#define | xmlSecGnuTLSKeyDataXdhId
#define | xmlSecGnuTLSTransformX25519Id
#define | xmlSecGnuTLSTransformX448Id
#define | xmlSecGnuTLSTransformEcdhId
#define | xmlSecGnuTLSKeyDataConcatKdfId
#define | xmlSecGnuTLSTransformConcatKdfId
#define | xmlSecGnuTLSKeyDataHmacId
#define | xmlSecGnuTLSTransformHmacSha1Id
#define | xmlSecGnuTLSTransformHmacSha224Id
#define | xmlSecGnuTLSTransformHmacSha256Id
#define | xmlSecGnuTLSTransformHmacSha384Id
#define | xmlSecGnuTLSTransformHmacSha512Id
#define | xmlSecGnuTLSKeyDataPbkdf2Id
#define | xmlSecGnuTLSTransformPbkdf2Id
#define | xmlSecGnuTLSKeyDataHkdfId
#define | xmlSecGnuTLSTransformHkdfId
#define | xmlSecGnuTLSKeyDataRsaId
#define | xmlSecGnuTLSTransformRsaSha1Id
#define | xmlSecGnuTLSTransformRsaSha224Id
#define | xmlSecGnuTLSTransformRsaSha256Id
#define | xmlSecGnuTLSTransformRsaSha384Id
#define | xmlSecGnuTLSTransformRsaSha512Id
#define | xmlSecGnuTLSTransformRsaPssSha256Id
#define | xmlSecGnuTLSTransformRsaPssSha384Id
#define | xmlSecGnuTLSTransformRsaPssSha512Id
#define | xmlSecGnuTLSTransformRsaPkcs1Id
#define | xmlSecGnuTLSTransformSha1Id
#define | xmlSecGnuTLSTransformSha224Id
#define | xmlSecGnuTLSTransformSha256Id
#define | xmlSecGnuTLSTransformSha384Id
#define | xmlSecGnuTLSTransformSha512Id
#define | xmlSecGnuTLSTransformSha3_224Id
#define | xmlSecGnuTLSTransformSha3_256Id
#define | xmlSecGnuTLSTransformSha3_384Id
#define | xmlSecGnuTLSTransformSha3_512Id
#define | xmlSecGnuTLSKeyDataDEREncodedKeyValueId

## Description

## Functions

### xmlSecCryptoGetFunctions_gnutls ()

    xmlSecCryptoDLFunctionsPtr
    xmlSecCryptoGetFunctions_gnutls (void);

Gets the pointer to xmlsec-gnutls functions table.

#### Returns

the xmlsec-gnutls functions table or NULL if an error occurs.

### xmlSecGnuTLSInit ()

    int
    xmlSecGnuTLSInit (void);

XMLSec library specific crypto engine initialization.

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSShutdown ()

    int
    xmlSecGnuTLSShutdown (void);

XMLSec library specific crypto engine shutdown.

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeysMngrInit ()

    int
    xmlSecGnuTLSKeysMngrInit (xmlSecKeysMngrPtr mngr);

Adds GnuTLS specific key data stores in keys manager.

#### Parameters

mngr | the pointer to keys manager. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSGenerateRandom ()

    int
    xmlSecGnuTLSGenerateRandom (xmlSecBufferPtr buffer,
                                xmlSecSize size);

Generates `size` random bytes and puts result in `buffer` .

#### Parameters

buffer | the destination buffer. |
size | the numer of bytes to generate. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSAsymmetricKeyCreatePub ()

    xmlSecKeyPtr
    xmlSecGnuTLSAsymmetricKeyCreatePub (gnutls_pubkey_t pubkey);

Creates XMLSec key from GnuTLS public key.

#### Parameters

pubkey | the pointer to GnuTLS public key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSAsymmetricKeyCreatePriv ()

    xmlSecKeyPtr
    xmlSecGnuTLSAsymmetricKeyCreatePriv (gnutls_privkey_t privkey);

Creates XMLSec key from GnuTLS private key.

#### Parameters

privkey | the pointer to GnuTLS private key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSAsymmetricKeyGetPub ()

    gnutls_pubkey_t
    xmlSecGnuTLSAsymmetricKeyGetPub (xmlSecKeyPtr key);

Gets GnuTLS public key from an XMLSec `key` .

#### Parameters

key | the pointer to XMLSec key. |

#### Returns

GnuTLS public key on success or a NULL value otherwise.

### xmlSecGnuTLSAsymmetricKeyGetPriv ()

    gnutls_privkey_t
    xmlSecGnuTLSAsymmetricKeyGetPriv (xmlSecKeyPtr key);

Gets GnuTLS private key from an XMLSec `key` .

#### Parameters

key | the pointer to XMLSec key. |

#### Returns

GnuTLS private key on success or a NULL value otherwise.

### xmlSecGnuTLSKeyDataAesGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataAesGetKlass (void);

The AES key data klass.

#### Returns

AES key data klass.

### xmlSecGnuTLSKeyDataAesSet ()

    int
    xmlSecGnuTLSKeyDataAesSet (xmlSecKeyDataPtr data,
                               const xmlSecByte *buf,
                               xmlSecSize bufSize);

Sets the value of AES key data.

#### Parameters

data | the pointer to AES key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformAes128CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes128CbcGetKlass
                                   (void);

AES 128 CBC encryption transform klass.

#### Returns

pointer to AES 128 CBC encryption transform.

### xmlSecGnuTLSTransformAes192CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes192CbcGetKlass
                                   (void);

AES 192 CBC encryption transform klass.

#### Returns

pointer to AES 192 CBC encryption transform.

### xmlSecGnuTLSTransformAes256CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes256CbcGetKlass
                                   (void);

AES 256 CBC encryption transform klass.

#### Returns

pointer to AES 256 CBC encryption transform.

### xmlSecGnuTLSTransformAes128GcmGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes128GcmGetKlass
                                   (void);

AES 128 GCM encryption transform klass.

#### Returns

pointer to AES 128 GCM encryption transform.

### xmlSecGnuTLSTransformAes192GcmGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes192GcmGetKlass
                                   (void);

AES 192 GCM encryption transform klass.

#### Returns

pointer to AES 192 GCM encryption transform.

### xmlSecGnuTLSTransformAes256GcmGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformAes256GcmGetKlass
                                   (void);

AES 256 GCM encryption transform klass.

#### Returns

pointer to AES 256 GCM encryption transform.

### xmlSecGnuTLSTransformKWAes128GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWAes128GetKlass (void);

The AES-128 key wrapper transform klass.

#### Returns

AES-128 key wrapper transform klass.

### xmlSecGnuTLSTransformKWAes192GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWAes192GetKlass (void);

The AES-192 kew wrapper transform klass.

#### Returns

AES-192 kew wrapper transform klass.

### xmlSecGnuTLSTransformKWAes256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWAes256GetKlass (void);

The AES-256 kew wrapper transform klass.

#### Returns

AES-256 kew wrapper transform klass.

### xmlSecGnuTLSKeyDataChaCha20GetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataChaCha20GetKlass (void);

The ChaCha20 key data klass.

#### Returns

ChaCha20 key data klass.

### xmlSecGnuTLSKeyDataChaCha20Set ()

    int
    xmlSecGnuTLSKeyDataChaCha20Set (xmlSecKeyDataPtr data,
                                    const xmlSecByte *buf,
                                    xmlSecSize bufSize);

Sets the value of ChaCha20 key data.

#### Parameters

data | the pointer to ChaCha20 key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformChaCha20GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformChaCha20GetKlass (void);

ChaCha20 stream cipher transform.

#### Returns

pointer to ChaCha20 transform.

### xmlSecGnuTLSTransformChaCha20Poly1305GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformChaCha20Poly1305GetKlass
                                   (void);

ChaCha20-Poly1305 AEAD encryption transform klass.

#### Returns

pointer to ChaCha20-Poly1305 encryption transform.

### xmlSecGnuTLSKeyDataDesGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataDesGetKlass (void);

The DES key data klass.

#### Returns

DES key data klass.

### xmlSecGnuTLSKeyDataDesSet ()

    int
    xmlSecGnuTLSKeyDataDesSet (xmlSecKeyDataPtr data,
                               const xmlSecByte *buf,
                               xmlSecSize bufSize);

Sets the value of DES key data.

#### Parameters

data | the pointer to DES key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformDes3CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformDes3CbcGetKlass (void);

Triple DES CBC encryption transform klass.

#### Returns

pointer to Triple DES encryption transform.

### xmlSecGnuTLSTransformKWDes3GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWDes3GetKlass (void);

The Triple DES key wrapper transform klass.

#### Returns

Triple DES key wrapper transform klass.

### xmlSecGnuTLSKeyDataCamelliaGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataCamelliaGetKlass (void);

The Camellia key data klass.

#### Returns

Camellia key data klass.

### xmlSecGnuTLSKeyDataCamelliaSet ()

    int
    xmlSecGnuTLSKeyDataCamelliaSet (xmlSecKeyDataPtr data,
                                    const xmlSecByte *buf,
                                    xmlSecSize bufSize);

Sets the value of Camellia key data.

#### Parameters

data | the pointer to Camellia key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformCamellia128CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformCamellia128CbcGetKlass
                                   (void);

Camellia 128 CBC encryption transform klass.

#### Returns

pointer to Camellia 128 CBC encryption transform.

### xmlSecGnuTLSTransformCamellia192CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformCamellia192CbcGetKlass
                                   (void);

Camellia 192 CBC encryption transform klass.

#### Returns

pointer to Camellia 192 CBC encryption transform.

### xmlSecGnuTLSTransformCamellia256CbcGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformCamellia256CbcGetKlass
                                   (void);

Camellia 256 CBC encryption transform klass.

#### Returns

pointer to Camellia 256 CBC encryption transform.

### xmlSecGnuTLSTransformKWCamellia128GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWCamellia128GetKlass
                                   (void);

The Camellia-128 kew wrapper transform klass.

#### Returns

Camellia-128 kew wrapper transform klass.

### xmlSecGnuTLSTransformKWCamellia192GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWCamellia192GetKlass
                                   (void);

The Camellia-192 kew wrapper transform klass.

#### Returns

Camellia-192 kew wrapper transform klass.

### xmlSecGnuTLSTransformKWCamellia256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformKWCamellia256GetKlass
                                   (void);

The Camellia-256 kew wrapper transform klass.

#### Returns

Camellia-256 kew wrapper transform klass.

### xmlSecGnuTLSKeyDataDsaGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataDsaGetKlass (void);

The DSA key data klass.

#### Returns

pointer to DSA key data klass.

### xmlSecGnuTLSKeyDataDsaAdoptKey ()

    int
    xmlSecGnuTLSKeyDataDsaAdoptKey (xmlSecKeyDataPtr data,
                                    gnutls_pubkey_t pubkey,
                                    gnutls_privkey_t privkey);

Sets the value of DSA key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to DSA key data. |
pubkey | the pointer to GnuTLS DSA key. |
privkey | the pointer to GnuTLS DSA key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataDsaGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataDsaGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS DSA public key from DSA key data.

#### Parameters

data | the pointer to DSA key data. |

#### Returns

pointer to GnuTLS public DSA key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataDsaGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataDsaGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS DSA private key from DSA key data.

#### Parameters

data | the pointer to DSA key data. |

#### Returns

pointer to GnuTLS private DSA key or NULL if an error occurs.

### xmlSecGnuTLSTransformDsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformDsaSha1GetKlass (void);

The DSA-SHA1 signature transform klass.

#### Returns

DSA-SHA1 signature transform klass.

### xmlSecGnuTLSTransformDsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformDsaSha256GetKlass
                                   (void);

The DSA-SHA2-256 signature transform klass.

#### Returns

DSA-SHA2-256 signature transform klass.

### xmlSecGnuTLSKeyDataEcGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataEcGetKlass (void);

The GnuTLS EC key data klass.

#### Returns

pointer to GnuTLS EC key data klass.

### xmlSecGnuTLSKeyDataEcAdoptKey ()

    int
    xmlSecGnuTLSKeyDataEcAdoptKey (xmlSecKeyDataPtr data,
                                   gnutls_pubkey_t pubkey,
                                   gnutls_privkey_t privkey);

Sets the value of EC key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to EC key data. |
pubkey | the pointer to GnuTLS EC key. |
privkey | the pointer to GnuTLS EC key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataEcGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataEcGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS EC public key from EC key data.

#### Parameters

data | the pointer to EC key data. |

#### Returns

pointer to GnuTLS public EC key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataEcGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataEcGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS EC private key from EC key data.

#### Parameters

data | the pointer to EC key data. |

#### Returns

pointer to GnuTLS private EC key or NULL if an error occurs.

### xmlSecGnuTLSTransformEcdsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha1GetKlass
                                   (void);

The ECDSA-SHA1 signature transform klass.

#### Returns

ECDSA-SHA1 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha224GetKlass
                                   (void);

The ECDSA-SHA2-224 signature transform klass.

#### Returns

ECDSA-SHA2-224 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha256GetKlass
                                   (void);

The ECDSA-SHA2-256 signature transform klass.

#### Returns

ECDSA-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha384GetKlass
                                   (void);

The ECDSA-SHA2-384 signature transform klass.

#### Returns

ECDSA-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha512GetKlass
                                   (void);

The ECDSA-SHA2-512 signature transform klass.

#### Returns

ECDSA-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha3_224GetKlass
                                   (void);

The ECDSA-SHA3-224 signature transform klass.

#### Returns

ECDSA-SHA3-224 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha3_256GetKlass
                                   (void);

The ECDSA-SHA3-256 signature transform klass.

#### Returns

ECDSA-SHA3-256 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha3_384GetKlass
                                   (void);

The ECDSA-SHA3-384 signature transform klass.

#### Returns

ECDSA-SHA3-384 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdsaSha3_512GetKlass
                                   (void);

The ECDSA-SHA3-512 signature transform klass.

#### Returns

ECDSA-SHA3-512 signature transform klass.

### xmlSecGnuTLSKeyDataGost2001GetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataGost2001GetKlass (void);

The GnuTLS GOST 2001 key data klass.

#### Returns

pointer to GnuTLS GOST 2001 key data klass.

### xmlSecGnuTLSKeyDataGost2001AdoptKey ()

    int
    xmlSecGnuTLSKeyDataGost2001AdoptKey (xmlSecKeyDataPtr data,
                                         gnutls_pubkey_t pubkey,
                                         gnutls_privkey_t privkey);

Sets the value of GOST 2001 key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to GOST 2001 key data. |
pubkey | the pointer to GnuTLS GOST 2001 key. |
privkey | the pointer to GnuTLS GOST 2001 key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataGost2001GetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataGost2001GetPublicKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2001 public key from GOST 2001 key data.

#### Parameters

data | the pointer to GOST 2001 key data. |

#### Returns

pointer to GnuTLS public GOST 2001 key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataGost2001GetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataGost2001GetPrivateKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2001 private key from GOST 2001 key data.

#### Parameters

data | the pointer to GOST 2001 key data. |

#### Returns

pointer to GnuTLS private GOST 2001 key or NULL if an error occurs.

### xmlSecGnuTLSTransformGostR3411_94GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGostR3411_94GetKlass
                                   (void);

GOSTR3411_94 digest transform klass.

#### Returns

pointer to GOSTR3411_94 digest transform klass.

### xmlSecGnuTLSTransformGost2001GostR3411_94GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGost2001GostR3411_94GetKlass
                                   (void);

The GOST2001 GOSTR3411_94 signature transform klass.

#### Returns

GOST2001 GOSTR3411_94 signature transform klass.

### xmlSecGnuTLSKeyDataGost2012_256GetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataGost2012_256GetKlass
                                   (void);

The GnuTLS GOST 2012 (256 bits) key data klass.

#### Returns

pointer to GnuTLS GOST 2012 (256 bits) key data klass.

### xmlSecGnuTLSKeyDataGost2012_256AdoptKey ()

    int
    xmlSecGnuTLSKeyDataGost2012_256AdoptKey
                                   (xmlSecKeyDataPtr data,
                                    gnutls_pubkey_t pubkey,
                                    gnutls_privkey_t privkey);

Sets the value of GOST 2012 (256 bits) key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to GOST 2012 (256 bits) key data. |
pubkey | the pointer to GnuTLS GOST 2012 (256 bits) key. |
privkey | the pointer to GnuTLS GOST 2012 (256 bits) key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataGost2012_256GetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataGost2012_256GetPublicKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2012 (256 bits) public key from GOST 2012 (256 bits) key data.

#### Parameters

data | the pointer to GOST 2012 (256 bits) key data. |

#### Returns

pointer to GnuTLS public GOST 2012 (256 bits) key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataGost2012_256GetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataGost2012_256GetPrivateKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2012 (256 bits) private key from GOST 2012 (256 bits) key data.

#### Parameters

data | the pointer to GOST 2012 (256 bits) key data. |

#### Returns

pointer to GnuTLS private GOST 2012 (256 bits) key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataGost2012_512GetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataGost2012_512GetKlass
                                   (void);

The GnuTLS GOST 2012 (512 bits) key data klass.

#### Returns

pointer to GnuTLS GOST 2012 (512 bits) key data klass.

### xmlSecGnuTLSKeyDataGost2012_512AdoptKey ()

    int
    xmlSecGnuTLSKeyDataGost2012_512AdoptKey
                                   (xmlSecKeyDataPtr data,
                                    gnutls_pubkey_t pubkey,
                                    gnutls_privkey_t privkey);

Sets the value of GOST 2012 (512 bits) key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to GOST 2012 (512 bits) key data. |
pubkey | the pointer to GnuTLS GOST 2012 (512 bits) key. |
privkey | the pointer to GnuTLS GOST 2012 (512 bits) key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataGost2012_512GetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataGost2012_512GetPublicKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2012 (512 bits) public key from GOST 2012 (512 bits) key data.

#### Parameters

data | the pointer to GOST 2012 (512 bits) key data. |

#### Returns

pointer to GnuTLS public GOST 2012 (512 bits) key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataGost2012_512GetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataGost2012_512GetPrivateKey
                                   (xmlSecKeyDataPtr data);

Gets the GnuTLS GOST 2012 (512 bits) private key from GOST 2012 (512 bits) key data.

#### Parameters

data | the pointer to GOST 2012 (512 bits) key data. |

#### Returns

pointer to GnuTLS private GOST 2012 (512 bits) key or NULL if an error occurs.

### xmlSecGnuTLSTransformGostR3411_2012_256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGostR3411_2012_256GetKlass
                                   (void);

GOST R 34.11-2012 256 bit digest transform klass.

#### Returns

pointer to GOST R 34.11-2012 256 bit digest transform klass.

### xmlSecGnuTLSTransformGostR3411_2012_512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGostR3411_2012_512GetKlass
                                   (void);

GOST R 34.11-2012 512 bit digest transform klass.

#### Returns

pointer to GOST R 34.11-2012 512 bit digest transform klass.

### xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256GetKlass
                                   (void);

The GOST R 34.10-2012 - GOST R 34.11-2012 256 bit signature transform klass.

#### Returns

GOST R 34.10-2012 - GOST R 34.11-2012 256 bit signature transform klass.

### xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512GetKlass
                                   (void);

The GOST R 34.10-2012 - GOST R 34.11-2012 512 bit signature transform klass.

#### Returns

GOST R 34.10-2012 - GOST R 34.11-2012 512 bit signature transform klass.

### xmlSecGnuTLSKeyDataMLDSAGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataMLDSAGetKlass (void);

The GnuTLS ML-DSA key data klass.

#### Returns

pointer to GnuTLS ML-DSA key data klass.

### xmlSecGnuTLSKeyDataMLDSAAdoptKey ()

    int
    xmlSecGnuTLSKeyDataMLDSAAdoptKey (xmlSecKeyDataPtr data,
                                      gnutls_pubkey_t pubkey,
                                      gnutls_privkey_t privkey);

Sets the value of ML-DSA key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to ML-DSA key data. |
pubkey | the pointer to GnuTLS ML-DSA key. |
privkey | the pointer to GnuTLS ML-DSA key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataMLDSAGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataMLDSAGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS ML-DSA public key from ML-DSA key data.

#### Parameters

data | the pointer to ML-DSA key data. |

#### Returns

pointer to GnuTLS public ML-DSA key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataMLDSAGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataMLDSAGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS ML-DSA private key from ML-DSA key data.

#### Parameters

data | the pointer to ML-DSA key data. |

#### Returns

pointer to GnuTLS private ML-DSA key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataMLDSAGetKL ()

    int
    xmlSecGnuTLSKeyDataMLDSAGetKL (xmlSecKeyDataPtr data);

Gets ML-DSA key (k, l) value: 44 corresponds to (4,4), 65 to (6,5) or 87 to (8,7).

#### Parameters

data | the pointer to ML-DSA key data. |

#### Returns

44, 65, or 87 on success or a negative value otherwise.

### xmlSecGnuTLSTransformMLDSA44GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformMLDSA44GetKlass (void);

The ML-DSA-44 signature transform klass.

#### Returns

ML-DSA-44 signature transform klass.

### xmlSecGnuTLSTransformMLDSA65GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformMLDSA65GetKlass (void);

The ML-DSA-65 signature transform klass.

#### Returns

ML-DSA-65 signature transform klass.

### xmlSecGnuTLSTransformMLDSA87GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformMLDSA87GetKlass (void);

The ML-DSA-87 signature transform klass.

#### Returns

ML-DSA-87 signature transform klass.

### xmlSecGnuTLSKeyDataEdDSAGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataEdDSAGetKlass (void);

The GnuTLS EdDSA key data klass.

#### Returns

pointer to GnuTLS EdDSA key data klass.

### xmlSecGnuTLSKeyDataEdDSAAdoptKey ()

    int
    xmlSecGnuTLSKeyDataEdDSAAdoptKey (xmlSecKeyDataPtr data,
                                      gnutls_pubkey_t pubkey,
                                      gnutls_privkey_t privkey);

Sets the value of EdDSA key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to EdDSA key data. |
pubkey | the pointer to GnuTLS EdDSA public key. |
privkey | the pointer to GnuTLS EdDSA private key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataEdDSAGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataEdDSAGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS EdDSA public key from EdDSA key data.

#### Parameters

data | the pointer to EdDSA key data. |

#### Returns

pointer to GnuTLS public EdDSA key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataEdDSAGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataEdDSAGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS EdDSA private key from EdDSA key data.

#### Parameters

data | the pointer to EdDSA key data. |

#### Returns

pointer to GnuTLS private EdDSA key or NULL if an error occurs.

### xmlSecGnuTLSTransformEdDSAEd25519GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEdDSAEd25519GetKlass
                                   (void);

The EdDSA-Ed25519 signature transform klass.

#### Returns

EdDSA-Ed25519 signature transform klass.

### xmlSecGnuTLSTransformEdDSAEd448GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEdDSAEd448GetKlass
                                   (void);

The EdDSA-Ed448 signature transform klass.

#### Returns

EdDSA-Ed448 signature transform klass.

### xmlSecGnuTLSKeyDataXdhGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataXdhGetKlass (void);

The GnuTLS XDH key data klass (X25519 and X448).

#### Returns

pointer to GnuTLS XDH key data klass.

### xmlSecGnuTLSKeyDataXdhAdoptKey ()

    int
    xmlSecGnuTLSKeyDataXdhAdoptKey (xmlSecKeyDataPtr data,
                                    gnutls_pubkey_t pubkey,
                                    gnutls_privkey_t privkey);

Sets the value of XDH key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to XDH key data. |
pubkey | the pointer to GnuTLS XDH public key. |
privkey | the pointer to GnuTLS XDH private key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataXdhGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataXdhGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS XDH public key from XDH key data.

#### Parameters

data | the pointer to XDH key data. |

#### Returns

pointer to GnuTLS public XDH key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataXdhGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataXdhGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS XDH private key from XDH key data.

#### Parameters

data | the pointer to XDH key data. |

#### Returns

pointer to GnuTLS private XDH key or NULL if an error occurs.

### xmlSecGnuTLSTransformX25519GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformX25519GetKlass (void);

The X25519 key agreement transform klass.

#### Returns

the X25519 key agreement transform klass.

### xmlSecGnuTLSTransformX448GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformX448GetKlass (void);

The X448 key agreement transform klass.

#### Returns

the X448 key agreement transform klass.

### xmlSecGnuTLSTransformEcdhGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformEcdhGetKlass (void);

The ECDH-ES key agreement transform klass.

#### Returns

the ECDH-ES key agreement transform klass.

### xmlSecGnuTLSKeyDataConcatKdfGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataConcatKdfGetKlass (void);

The ConcatKDF key data klass.

#### Returns

ConcatKDF key data klass.

### xmlSecGnuTLSKeyDataConcatKdfSet ()

    int
    xmlSecGnuTLSKeyDataConcatKdfSet (xmlSecKeyDataPtr data,
                                     const xmlSecByte *buf,
                                     xmlSecSize bufSize);

Sets the value of ConcatKDF key data.

#### Parameters

data | the pointer to ConcatKDF key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformConcatKdfGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformConcatKdfGetKlass
                                   (void);

The ConcatKDF key derivation transform klass.

#### Returns

the ConcatKDF key derivation transform klass.

### xmlSecGnuTLSKeyDataHmacGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataHmacGetKlass (void);

The HMAC key data klass.

#### Returns

HMAC key data klass.

### xmlSecGnuTLSKeyDataHmacSet ()

    int
    xmlSecGnuTLSKeyDataHmacSet (xmlSecKeyDataPtr data,
                                const xmlSecByte *buf,
                                xmlSecSize bufSize);

Sets the value of HMAC key data.

#### Parameters

data | the pointer to HMAC key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformHmacSha1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHmacSha1GetKlass (void);

The HMAC-SHA1 transform klass.

#### Returns

the HMAC-SHA1 transform klass.

### xmlSecGnuTLSTransformHmacSha224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHmacSha224GetKlass
                                   (void);

The HMAC-SHA224 transform klass.

#### Returns

the HMAC-SHA224 transform klass.

### xmlSecGnuTLSTransformHmacSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHmacSha256GetKlass
                                   (void);

The HMAC-SHA256 transform klass.

#### Returns

the HMAC-SHA256 transform klass.

### xmlSecGnuTLSTransformHmacSha384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHmacSha384GetKlass
                                   (void);

The HMAC-SHA384 transform klass.

#### Returns

the HMAC-SHA384 transform klass.

### xmlSecGnuTLSTransformHmacSha512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHmacSha512GetKlass
                                   (void);

The HMAC-SHA512 transform klass.

#### Returns

the HMAC-SHA512 transform klass.

### xmlSecGnuTLSKeyDataPbkdf2GetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataPbkdf2GetKlass (void);

The PBKDF2 key data klass.

#### Returns

PBKDF2 key data klass.

### xmlSecGnuTLSKeyDataPbkdf2Set ()

    int
    xmlSecGnuTLSKeyDataPbkdf2Set (xmlSecKeyDataPtr data,
                                  const xmlSecByte *buf,
                                  xmlSecSize bufSize);

Sets the value of PBKDF2 key data.

#### Parameters

data | the pointer to PBKDF2 key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformPbkdf2GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformPbkdf2GetKlass (void);

The PBKDF2 key derivation transform klass.

#### Returns

the PBKDF2 key derivation transform klass.

### xmlSecGnuTLSKeyDataHkdfGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataHkdfGetKlass (void);

The HKDF key data klass.

#### Returns

HKDF key data klass.

### xmlSecGnuTLSKeyDataHkdfSet ()

    int
    xmlSecGnuTLSKeyDataHkdfSet (xmlSecKeyDataPtr data,
                                const xmlSecByte *buf,
                                xmlSecSize bufSize);

Sets the value of HKDF key data.

#### Parameters

data | the pointer to HKDF key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecGnuTLSTransformHkdfGetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformHkdfGetKlass (void);

The HKDF key derivation transform klass.

#### Returns

the HKDF key derivation transform klass.

### xmlSecGnuTLSKeyDataRsaGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataRsaGetKlass (void);

The RSA key data klass.

#### Returns

pointer to RSA key data klass.

### xmlSecGnuTLSKeyDataRsaAdoptKey ()

    int
    xmlSecGnuTLSKeyDataRsaAdoptKey (xmlSecKeyDataPtr data,
                                    gnutls_pubkey_t pubkey,
                                    gnutls_privkey_t privkey);

Sets the value of RSA key data. The `pubkey` and `privkey` will be owned by the `data` on success.

#### Parameters

data | the pointer to RSA key data. |
pubkey | the pointer to GnuTLS RSA key. |
privkey | the pointer to GnuTLS RSA key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecGnuTLSKeyDataRsaGetPublicKey ()

    gnutls_pubkey_t
    xmlSecGnuTLSKeyDataRsaGetPublicKey (xmlSecKeyDataPtr data);

Gets the GnuTLS RSA public key from RSA key data.

#### Parameters

data | the pointer to RSA key data. |

#### Returns

pointer to GnuTLS public RSA key or NULL if an error occurs.

### xmlSecGnuTLSKeyDataRsaGetPrivateKey ()

    gnutls_privkey_t
    xmlSecGnuTLSKeyDataRsaGetPrivateKey (xmlSecKeyDataPtr data);

Gets the GnuTLS RSA private key from RSA key data.

#### Parameters

data | the pointer to RSA key data. |

#### Returns

pointer to GnuTLS private RSA key or NULL if an error occurs.

### xmlSecGnuTLSTransformRsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaSha1GetKlass (void);

The RSA-SHA1 signature transform klass.

#### Returns

RSA-SHA1 signature transform klass.

### xmlSecGnuTLSTransformRsaSha224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaSha224GetKlass
                                   (void);

The RSA-SHA2-224 signature transform klass.

#### Returns

RSA-SHA2-224 signature transform klass.

### xmlSecGnuTLSTransformRsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaSha256GetKlass
                                   (void);

The RSA-SHA2-256 signature transform klass.

#### Returns

RSA-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformRsaSha384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaSha384GetKlass
                                   (void);

The RSA-SHA2-384 signature transform klass.

#### Returns

RSA-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformRsaSha512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaSha512GetKlass
                                   (void);

The RSA-SHA2-512 signature transform klass.

#### Returns

RSA-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaPssSha256GetKlass
                                   (void);

The RSA-PSS-SHA2-256 signature transform klass.

#### Returns

RSA-PSS-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaPssSha384GetKlass
                                   (void);

The RSA-PSS-SHA2-384 signature transform klass.

#### Returns

RSA-PSS-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaPssSha512GetKlass
                                   (void);

The RSA-PSS-SHA2-512 signature transform klass.

#### Returns

RSA-PSS-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformRsaPkcs1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformRsaPkcs1GetKlass (void);

The RSA-PKCS1 key transport transform klass.

#### Returns

RSA-PKCS1 key transport transform klass.

### xmlSecGnuTLSTransformSha1GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha1GetKlass (void);

SHA-1 digest transform klass.

#### Returns

pointer to SHA-1 digest transform klass.

### xmlSecGnuTLSTransformSha224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha224GetKlass (void);

SHA2-224 digest transform klass.

#### Returns

pointer to SHA2-224 digest transform klass.

### xmlSecGnuTLSTransformSha256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha256GetKlass (void);

SHA2-256 digest transform klass.

#### Returns

pointer to SHA2-256 digest transform klass.

### xmlSecGnuTLSTransformSha384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha384GetKlass (void);

SHA2-384 digest transform klass.

#### Returns

pointer to SHA2-384 digest transform klass.

### xmlSecGnuTLSTransformSha512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha512GetKlass (void);

SHA2-512 digest transform klass.

#### Returns

pointer to SHA2-512 digest transform klass.

### xmlSecGnuTLSTransformSha3_224GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha3_224GetKlass (void);

SHA3-224 digest transform klass.

#### Returns

pointer to SHA3-224 digest transform klass.

### xmlSecGnuTLSTransformSha3_256GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha3_256GetKlass (void);

SHA3-256 digest transform klass.

#### Returns

pointer to SHA3-256 digest transform klass.

### xmlSecGnuTLSTransformSha3_384GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha3_384GetKlass (void);

SHA3-384 digest transform klass.

#### Returns

pointer to SHA3-384 digest transform klass.

### xmlSecGnuTLSTransformSha3_512GetKlass ()

    xmlSecTransformId
    xmlSecGnuTLSTransformSha3_512GetKlass (void);

SHA3-512 digest transform klass.

#### Returns

pointer to SHA3-512 digest transform klass.

### xmlSecGnuTLSKeyDataDEREncodedKeyValueGetKlass ()

    xmlSecKeyDataId
    xmlSecGnuTLSKeyDataDEREncodedKeyValueGetKlass
                                   (void);

https://www.w3.org/TR/xmldsig-core1/sec-DEREncodedKeyValue

         <!-- targetNamespace="http://www.w3.org/2009/xmldsig11#" -->
         <element name="DEREncodedKeyValue" type="dsig11:DEREncodedKeyValueType" />
         <complexType name="DEREncodedKeyValueType">
             <simpleContent>
                 <extension base="base64Binary">
                     <attribute name="Id" type="ID" use="optional"/>
                 </extension>
             </simpleContent>
         </complexType>

#### Returns

the <dsig11:DEREncodedKeyValue/>element processing key data klass.

## Types and Values

### xmlSecGnuTLSKeyDataAesId

    #define             xmlSecGnuTLSKeyDataAesId

`xmlSecGnuTLSKeyDataAesId` is deprecated and should not be used in newly-written code.

The AES key data klass.

### xmlSecGnuTLSTransformAes128CbcId

    #define             xmlSecGnuTLSTransformAes128CbcId

The AES128 CBC cipher transform klass.

### xmlSecGnuTLSTransformAes192CbcId

    #define             xmlSecGnuTLSTransformAes192CbcId

The AES192 CBC cipher transform klass.

### xmlSecGnuTLSTransformAes256CbcId

    #define             xmlSecGnuTLSTransformAes256CbcId

The AES256 CBC cipher transform klass.

### xmlSecGnuTLSTransformAes128GcmId

    #define             xmlSecGnuTLSTransformAes128GcmId

The AES128 GCM cipher transform klass.

### xmlSecGnuTLSTransformAes192GcmId

    #define             xmlSecGnuTLSTransformAes192GcmId

The AES192 GCM cipher transform klass.

### xmlSecGnuTLSTransformAes256GcmId

    #define             xmlSecGnuTLSTransformAes256GcmId

The AES256 GCM cipher transform klass.

### xmlSecGnuTLSTransformKWAes128Id

    #define             xmlSecGnuTLSTransformKWAes128Id

The AES 128 key wrap transform klass.

### xmlSecGnuTLSTransformKWAes192Id

    #define             xmlSecGnuTLSTransformKWAes192Id

The AES 192 key wrap transform klass.

### xmlSecGnuTLSTransformKWAes256Id

    #define             xmlSecGnuTLSTransformKWAes256Id

The AES 256 key wrap transform klass.

### xmlSecGnuTLSKeyDataChaCha20Id

    #define             xmlSecGnuTLSKeyDataChaCha20Id

The ChaCha20 key data klass.

### xmlSecGnuTLSTransformChaCha20Id

    #define             xmlSecGnuTLSTransformChaCha20Id

The ChaCha20 stream cipher transform klass.

### xmlSecGnuTLSTransformChaCha20Poly1305Id

    #define             xmlSecGnuTLSTransformChaCha20Poly1305Id

The ChaCha20-Poly1305 AEAD cipher transform klass.

### xmlSecGnuTLSKeyDataDesId

    #define             xmlSecGnuTLSKeyDataDesId

The DES key data klass.

### xmlSecGnuTLSTransformDes3CbcId

    #define             xmlSecGnuTLSTransformDes3CbcId

The DES3 CBC cipher transform klass.

### xmlSecGnuTLSTransformKWDes3Id

    #define             xmlSecGnuTLSTransformKWDes3Id

The DES3 KW transform klass.

### xmlSecGnuTLSKeyDataCamelliaId

    #define             xmlSecGnuTLSKeyDataCamelliaId

The Camellia key data klass.

### xmlSecGnuTLSTransformCamellia128CbcId

    #define             xmlSecGnuTLSTransformCamellia128CbcId

The Camellia128 CBC cipher transform klass.

### xmlSecGnuTLSTransformCamellia192CbcId

    #define             xmlSecGnuTLSTransformCamellia192CbcId

The Camellia192 CBC cipher transform klass.

### xmlSecGnuTLSTransformCamellia256CbcId

    #define             xmlSecGnuTLSTransformCamellia256CbcId

The Camellia256 CBC cipher transform klass.

### xmlSecGnuTLSTransformKWCamellia128Id

    #define             xmlSecGnuTLSTransformKWCamellia128Id

The Camellia 128 key wrap transform klass.

### xmlSecGnuTLSTransformKWCamellia192Id

    #define             xmlSecGnuTLSTransformKWCamellia192Id

The Camellia 192 key wrap transform klass.

### xmlSecGnuTLSTransformKWCamellia256Id

    #define             xmlSecGnuTLSTransformKWCamellia256Id

The Camellia 256 key wrap transform klass.

### xmlSecGnuTLSKeyDataDsaId

    #define             xmlSecGnuTLSKeyDataDsaId

The DSA key klass.

### xmlSecGnuTLSTransformDsaSha1Id

    #define             xmlSecGnuTLSTransformDsaSha1Id

The DSA SHA1 signature transform klass.

### xmlSecGnuTLSTransformDsaSha256Id

    #define             xmlSecGnuTLSTransformDsaSha256Id

The DSA SHA2-256 signature transform klass.

### xmlSecGnuTLSKeyDataEcId

    #define xmlSecGnuTLSKeyDataEcId         xmlSecGnuTLSKeyDataEcGetKlass()

The EC key klass.

### xmlSecGnuTLSTransformEcdsaSha1Id

    #define             xmlSecGnuTLSTransformEcdsaSha1Id

The ECDSA-SHA1 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha224Id

    #define             xmlSecGnuTLSTransformEcdsaSha224Id

The ECDSA-SHA2-224 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha256Id

    #define             xmlSecGnuTLSTransformEcdsaSha256Id

The ECDSA-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha384Id

    #define             xmlSecGnuTLSTransformEcdsaSha384Id

The ECDSA-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha512Id

    #define             xmlSecGnuTLSTransformEcdsaSha512Id

The ECDSA-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_224Id

    #define             xmlSecGnuTLSTransformEcdsaSha3_224Id

The ECDSA-SHA3-224 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_256Id

    #define             xmlSecGnuTLSTransformEcdsaSha3_256Id

The ECDSA-SHA3-256 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_384Id

    #define             xmlSecGnuTLSTransformEcdsaSha3_384Id

The ECDSA-SHA3-384 signature transform klass.

### xmlSecGnuTLSTransformEcdsaSha3_512Id

    #define             xmlSecGnuTLSTransformEcdsaSha3_512Id

The ECDSA-SHA3-512 signature transform klass.

### xmlSecGnuTLSKeyDataGost2001Id

    #define xmlSecGnuTLSKeyDataGost2001Id   xmlSecGnuTLSKeyDataGost2001GetKlass     ()

The GOST 2001 key klass.

### xmlSecGnuTLSTransformGostR3411_94Id

    #define             xmlSecGnuTLSTransformGostR3411_94Id

The GOSTR3411_94 digest transform klass.

### xmlSecGnuTLSTransformGost2001GostR3411_94Id

    #define             xmlSecGnuTLSTransformGost2001GostR3411_94Id

The GOST2001 GOSTR3411_94 signature transform klass.

### xmlSecGnuTLSKeyDataGost2012_256Id

    #define xmlSecGnuTLSKeyDataGost2012_256Id   xmlSecGnuTLSKeyDataGost2012_256GetKlass()

The GOST R 34.10-2012 256 bit key klass.

### xmlSecGnuTLSKeyDataGost2012_512Id

    #define xmlSecGnuTLSKeyDataGost2012_512Id   xmlSecGnuTLSKeyDataGost2012_512GetKlass()

The GOST R 34.10-2012 512 bit key klass.

### xmlSecGnuTLSTransformGostR3411_2012_256Id

    #define             xmlSecGnuTLSTransformGostR3411_2012_256Id

The GOST R 34.11-2012 256 bit digest transform klass.

### xmlSecGnuTLSTransformGostR3411_2012_512Id

    #define             xmlSecGnuTLSTransformGostR3411_2012_512Id

The GOST R 34.11-2012 512 bit digest transform klass.

### xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256Id

    #define             xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_256Id

The GOST R 34.10-2012 - GOST R 3411-2012 256 bit signature transform klass.

### xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512Id

    #define             xmlSecGnuTLSTransformGostR3410_2012GostR3411_2012_512Id

The GOST R 34.10-2012 - GOST R 3411-2012 512 bit signature transform klass.

### xmlSecGnuTLSKeyDataMLDSAId

    #define xmlSecGnuTLSKeyDataMLDSAId   xmlSecGnuTLSKeyDataMLDSAGetKlass()

The ML-DSA key klass (post-quantum signature algorithm per FIPS 204).

### xmlSecGnuTLSTransformMLDSA44Id

    #define             xmlSecGnuTLSTransformMLDSA44Id

The ML-DSA-44 signature transform klass.

### xmlSecGnuTLSTransformMLDSA65Id

    #define             xmlSecGnuTLSTransformMLDSA65Id

The ML-DSA-65 signature transform klass.

### xmlSecGnuTLSTransformMLDSA87Id

    #define             xmlSecGnuTLSTransformMLDSA87Id

The ML-DSA-87 signature transform klass.

### xmlSecGnuTLSKeyDataEdDSAId

    #define xmlSecGnuTLSKeyDataEdDSAId   xmlSecGnuTLSKeyDataEdDSAGetKlass()

The EdDSA key klass (Ed25519 and Ed448).

### xmlSecGnuTLSTransformEdDSAEd25519Id

    #define             xmlSecGnuTLSTransformEdDSAEd25519Id

The EdDSA-Ed25519 signature transform klass.

### xmlSecGnuTLSTransformEdDSAEd448Id

    #define             xmlSecGnuTLSTransformEdDSAEd448Id

The EdDSA-Ed448 signature transform klass.

### xmlSecGnuTLSKeyDataXdhId

    #define xmlSecGnuTLSKeyDataXdhId   xmlSecGnuTLSKeyDataXdhGetKlass()

The XDH key klass (X25519 and X448).

### xmlSecGnuTLSTransformX25519Id

    #define             xmlSecGnuTLSTransformX25519Id

The X25519 key agreement transform klass.

### xmlSecGnuTLSTransformX448Id

    #define             xmlSecGnuTLSTransformX448Id

The X448 key agreement transform klass.

### xmlSecGnuTLSTransformEcdhId

    #define             xmlSecGnuTLSTransformEcdhId

The ECDH-ES key agreement transform klass.

### xmlSecGnuTLSKeyDataConcatKdfId

    #define             xmlSecGnuTLSKeyDataConcatKdfId

The ConcatKDF key klass.

### xmlSecGnuTLSTransformConcatKdfId

    #define             xmlSecGnuTLSTransformConcatKdfId

The ConcatKDF key derivation transform klass.

### xmlSecGnuTLSKeyDataHmacId

    #define             xmlSecGnuTLSKeyDataHmacId

The HMAC key klass.

### xmlSecGnuTLSTransformHmacSha1Id

    #define             xmlSecGnuTLSTransformHmacSha1Id

The HMAC with SHA1 signature transform klass.

### xmlSecGnuTLSTransformHmacSha224Id

    #define             xmlSecGnuTLSTransformHmacSha224Id

The HMAC with SHA2-224 signature transform klass.

### xmlSecGnuTLSTransformHmacSha256Id

    #define             xmlSecGnuTLSTransformHmacSha256Id

The HMAC with SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformHmacSha384Id

    #define             xmlSecGnuTLSTransformHmacSha384Id

The HMAC with SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformHmacSha512Id

    #define             xmlSecGnuTLSTransformHmacSha512Id

The HMAC with SHA2-512 signature transform klass.

### xmlSecGnuTLSKeyDataPbkdf2Id

    #define             xmlSecGnuTLSKeyDataPbkdf2Id

The PBKDF2 key klass.

### xmlSecGnuTLSTransformPbkdf2Id

    #define             xmlSecGnuTLSTransformPbkdf2Id

The PBKDF2 key derivation transform klass.

### xmlSecGnuTLSKeyDataHkdfId

    #define             xmlSecGnuTLSKeyDataHkdfId

The HKDF key klass.

### xmlSecGnuTLSTransformHkdfId

    #define             xmlSecGnuTLSTransformHkdfId

The HKDF key derivation transform klass.

### xmlSecGnuTLSKeyDataRsaId

    #define             xmlSecGnuTLSKeyDataRsaId

The RSA key klass.

### xmlSecGnuTLSTransformRsaSha1Id

    #define             xmlSecGnuTLSTransformRsaSha1Id

The RSA-SHA1 signature transform klass.

### xmlSecGnuTLSTransformRsaSha224Id

    #define             xmlSecGnuTLSTransformRsaSha224Id

The RSA-SHA2-224 signature transform klass.

### xmlSecGnuTLSTransformRsaSha256Id

    #define             xmlSecGnuTLSTransformRsaSha256Id

The RSA-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformRsaSha384Id

    #define             xmlSecGnuTLSTransformRsaSha384Id

The RSA-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformRsaSha512Id

    #define             xmlSecGnuTLSTransformRsaSha512Id

The RSA-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha256Id

    #define             xmlSecGnuTLSTransformRsaPssSha256Id

The RSA-PSS-SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha384Id

    #define             xmlSecGnuTLSTransformRsaPssSha384Id

The RSA-PSS-SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformRsaPssSha512Id

    #define             xmlSecGnuTLSTransformRsaPssSha512Id

The RSA-PSS-SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformRsaPkcs1Id

    #define             xmlSecGnuTLSTransformRsaPkcs1Id

The RSA PKCS1 key transport transform klass.

### xmlSecGnuTLSTransformSha1Id

    #define             xmlSecGnuTLSTransformSha1Id

The HMAC with SHA1 signature transform klass.

### xmlSecGnuTLSTransformSha224Id

    #define             xmlSecGnuTLSTransformSha224Id

The SHA2-224 digest transform klass.

### xmlSecGnuTLSTransformSha256Id

    #define             xmlSecGnuTLSTransformSha256Id

The HMAC with SHA2-256 signature transform klass.

### xmlSecGnuTLSTransformSha384Id

    #define             xmlSecGnuTLSTransformSha384Id

The HMAC with SHA2-384 signature transform klass.

### xmlSecGnuTLSTransformSha512Id

    #define             xmlSecGnuTLSTransformSha512Id

The HMAC with SHA2-512 signature transform klass.

### xmlSecGnuTLSTransformSha3_224Id

    #define             xmlSecGnuTLSTransformSha3_224Id

The SHA3-224 digest transform klass.

### xmlSecGnuTLSTransformSha3_256Id

    #define             xmlSecGnuTLSTransformSha3_256Id

The SHA3-256 digest transform klass.

### xmlSecGnuTLSTransformSha3_384Id

    #define             xmlSecGnuTLSTransformSha3_384Id

The HMAC with SHA3-384 signature transform klass.

### xmlSecGnuTLSTransformSha3_512Id

    #define             xmlSecGnuTLSTransformSha3_512Id

The HMAC with SHA3-512 signature transform klass.

### xmlSecGnuTLSKeyDataDEREncodedKeyValueId

    #define xmlSecGnuTLSKeyDataDEREncodedKeyValueId  xmlSecGnuTLSKeyDataDEREncodedKeyValueGetKlass()

The GnuTLS DEREncodedKeyValue data klass.